#include <stdio.h>
#include <string>
#include <math.h>
#include "glut.h"
#pragma comment (lib, "glut32.lib")
using namespace std;

char dir[256];
FILE * fp;
char * file;
float floatval;

float tofloat(long in)
{
	float out = *reinterpret_cast<float*>(&in);
	return out;
}

void drawmodel()
{
	fp = fopen(dir,"rb");
	fseek(fp,0,SEEK_END);
	long size = ftell(fp);
	fseek(fp,0,SEEK_SET);
	file = (char*) malloc(sizeof(char)*size);
	fread(file,1,size,fp);

	long nomodels = (file[0]<<24) + (file[1]<<16) + (file[2]<<8) + (file[3]);
	long modelbaseoff = (file[4]<<24) + (file[5]<<16) + (file[6]<<8) + (file[7]);
	for (int i=0; i<nomodels; i++)
	{
		long modeloff = modelbaseoff + (file[8+(8*i)]<<24) + (file[9+(8*i)]<<16) + (file[10+(8*i)]<<8) + (file[11+(8*i)]);
		if(((file[8+(8*i)]<<24) + (file[9+(8*i)]<<16) + (file[10+(8*i)]<<8) + (file[11+(8*i)])) != 0xFFFFFFFF)
		{
			short txutotal = (file[modeloff+24]<<8) + file[modeloff+25];
			short txusect1 = (file[modeloff+26]<<8) + file[modeloff+27];
			short txusect2 = (file[modeloff+28]<<8) + file[modeloff+29];
			fseek(fp,modeloff+(32*txutotal)+64,SEEK_SET);
			for (short j=0; j<(txutotal|(txusect1+txusect2)); j++)
			{
				fseek(fp,28,SEEK_CUR);
				long flags=((getc(fp)<<24) + (getc(fp)<<16) + (getc(fp)<<8) + (getc(fp)));
				fseek(fp,8,SEEK_CUR);
				long chunk1size=((getc(fp)<<24) + (getc(fp)<<16) + (getc(fp)<<8) + (getc(fp)));
				long chunk2size=((getc(fp)<<24) + (getc(fp)<<16) + (getc(fp)<<8) + (getc(fp)));
				fseek(fp,49,SEEK_CUR);
				long modeldataoff = ftell(fp);
				for (int k=0; k<(chunk1size-1); k+=0)
				{
					char mode = getc(fp);
					short nopoints = ((getc(fp)<<8) + (getc(fp)));
					if ((mode&0xFF)==0x98)
					{
						float xn,yn,zn,s,t,x,y,z;
						long c;
						glBegin(GL_TRIANGLE_STRIP);
						for(int l=0; l<nopoints; l++)
						{
							if(flags&0x00000001)
							{
								fseek(fp,1,SEEK_CUR);
							}
							if(flags&0x00000200)
							{
								x=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								y=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								z=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glVertex3f(x,y,z);
							}
							if(flags&0x00000400)
							{
								xn=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								yn=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								zn=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glNormal3f(xn,yn,zn);
							}
							if(flags&0x00000800)
							{
								c=((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glColor4ub((c&0xFF000000)>>24,(c&0x00FF0000)>>16,(c&0x0000FF00)>>8,(c&0x000000FF));
							}
							if(flags&0x00002000)
							{
								s=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								t=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glTexCoord2f(s,t);
							}
							if(flags&0x00004000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x00008000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x02000000)
							{
								fseek(fp,24,SEEK_CUR);
							}
						}
						glEnd();
						k+=32;
					}
					if ((mode&0xFF)==0x99)
					{
						short xn,yn,zn,s,t,x,y,z;
						long c;
						glBegin(GL_TRIANGLE_STRIP);
						for(int l=0; l<nopoints; l++)
						{
							if(flags&0x00000001)
							{
								fseek(fp,1,SEEK_CUR);
							}
							if(flags&0x00000200)
							{
								x=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								y=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								z=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								glVertex3f(x,y,z);
							}
							if(flags&0x00000400)
							{
								xn=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								yn=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								zn=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								glNormal3f(xn,yn,zn);
							}
							if(flags&0x00000800)
							{
								c=((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glColor4ub((c&0xFF000000)>>24,(c&0x00FF0000)>>16,(c&0x0000FF00)>>8,(c&0x000000FF));
							}
							if(flags&0x00002000)
							{
								s=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								t=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								glTexCoord2f(s,t);
							}
							if(flags&0x00004000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x00008000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x02000000)
							{
								fseek(fp,24,SEEK_CUR);
							}
						}
						glEnd();
						k+=32;
					}
					if ((mode&0xFF)==0x00)
					{
						k=(chunk1size-1);
						fseek(fp,modeldataoff+chunk1size,SEEK_SET);
					}
				}
				modeldataoff = ftell(fp);
				for (int k=0; k<(chunk2size-1); k+=0)
				{
					char mode = getc(fp);
					short nopoints = ((getc(fp)<<8) + (getc(fp)));
					if ((mode&0xFF)==0x98)
					{
						float xn,yn,zn,s,t,x,y,z;
						long c;
						glBegin(GL_TRIANGLE_STRIP);
						for(int l=0; l<nopoints; l++)
						{
							if(flags&0x00000001)
							{
								fseek(fp,1,SEEK_CUR);
							}
							if(flags&0x00000200)
							{
								x=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								y=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								z=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glVertex3f(x,y,z);
							}
							if(flags&0x00000400)
							{
								xn=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								yn=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								zn=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glNormal3f(xn,yn,zn);
							}
							if(flags&0x00000800)
							{
								c=((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glColor4ub((c&0xFF000000)>>24,(c&0x00FF0000)>>16,(c&0x0000FF00)>>8,(c&0x000000FF));
							}
							if(flags&0x00002000)
							{
								s=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								t=tofloat((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glTexCoord2f(s,t);
							}
							if(flags&0x00004000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x00008000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x02000000)
							{
								fseek(fp,24,SEEK_CUR);
							}
						}
						glEnd();
						k+=32;
					}
					if ((mode&0xFF)==0x99)
					{
						short xn,yn,zn,s,t,x,y,z;
						long c;
						glBegin(GL_TRIANGLE_STRIP);
						for(int l=0; l<nopoints; l++)
						{
							if(flags&0x00000001)
							{
								fseek(fp,1,SEEK_CUR);
							}
							if(flags&0x00000200)
							{
								x=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								y=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								z=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								glVertex3f(x,y,z);
							}
							if(flags&0x00000400)
							{
								xn=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								yn=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								zn=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								glNormal3f(xn,yn,zn);
							}
							if(flags&0x00000800)
							{
								c=((getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp)));
								glColor4ub((c&0xFF000000)>>24,(c&0x00FF0000)>>16,(c&0x0000FF00)>>8,(c&0x000000FF));
							}
							if(flags&0x00002000)
							{
								s=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								t=(getc(fp)<<24)+(getc(fp)<<16)+(getc(fp)<<8)+(getc(fp));
								glTexCoord2f(s,t);
							}
							if(flags&0x00004000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x00008000)
							{
								fseek(fp,8,SEEK_CUR);
							}
							if(flags&0x02000000)
							{
								fseek(fp,24,SEEK_CUR);
							}
						}
						glEnd();
						k+=32;
					}
					if ((mode&0xFF)==0x00)
					{
						k=(chunk2size-1);
						fseek(fp,modeldataoff+chunk2size,SEEK_SET);
					}
				}
				fseek(fp,-1,SEEK_CUR);
			}
		}
		//printf("Created %d of %d models\n",i+1,nomodels);
	}
	fclose(fp);
	free(file);
	//printf("Done!\n");
	glFlush();
}

void init(void)
{
	glClearColor(0.0, 0.0, 0.0, 1.0);
	glMatrixMode(GL_PROJECTION);
    glLoadIdentity();
	glOrtho(-128,128,-128,128,-256,256);
}

void getkey(unsigned char key, int x, int y)
{
	if(key==115)
	{
		glRotatef(15,1,0,0);
	}
	if(key==119)
	{
		glRotatef(-15,1,0,0);
	}
	if(key==100)
	{
		glRotatef(15,0,1,0);
	}
	if(key==97)
	{
		glRotatef(-15,0,1,0);
	}
	if(key==113)
	{
		glRotatef(15,0,0,1);
	}
	if(key==101)
	{
		glRotatef(-15,0,0,1);
	}
	if(key==105)
	{
		glTranslatef(0,5,0);
	}
	if(key==107)
	{
		glTranslatef(0,-5,0);
	}
	if(key==106)
	{
		glTranslatef(5,0,0);
	}
	if(key==108)
	{
		glTranslatef(-5,0,0);
	}
	if(key==111)
	{
		glTranslatef(0,0,5);
	}
	if(key==117)
	{
		glTranslatef(0,0,-5);
	}
	if(key==102)
	{
		glScalef(.5,.5,.5);
	}
	if(key==104)
	{
		glScalef(2,2,2);
	}
	glClear(GL_COLOR_BUFFER_BIT);
	glutPostRedisplay();
}

void getskey(int key, int x, int y)
{

}

int main(int argc, char** argv)
{
	printf("==============================\nSUPER MONKEY BALL LEVEL VIEWER\n==============================\n\nGMA PATH:\n\n");
	gets(dir);

	glutInit(&argc, argv);
	glutInitDisplayMode (GLUT_SINGLE | GLUT_RGBA);
	glutInitWindowSize (256, 256); 
	glutInitWindowPosition (0, 0);
	glutCreateWindow ("SMB/SMB2 LV");
	init();
	glEnable (GL_BLEND);
	glBlendFunc (GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glutDisplayFunc(drawmodel);
	glutKeyboardFunc(getkey);
	glutSpecialFunc(getskey);

	glutMainLoop();
	return 0;
}